Liferay.Loader.define("layout-taglib@5.4.20/select_layout/js/SelectLayout.es", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', '@frontend-taglib-clay$clayui/form', '@frontend-taglib-clay$clayui/layout', '@frontend-taglib-clay$clayui/management-toolbar', 'frontend-js-components-web', 'frontend-js-web', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', './SearchResults'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _button = require("@frontend-taglib-clay$clayui/button");

    var _form = require("@frontend-taglib-clay$clayui/form");

    var _layout = _interopRequireDefault(require("@frontend-taglib-clay$clayui/layout"));

    var _managementToolbar = _interopRequireDefault(require("@frontend-taglib-clay$clayui/management-toolbar"));

    var _frontendJsComponentsWeb = require("frontend-js-components-web");

    var _frontendJsWeb = require("frontend-js-web");

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _SearchResults = _interopRequireDefault(require("./SearchResults"));

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _toConsumableArray(arr) {
      return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
    }

    function _nonIterableSpread() {
      throw new TypeError("Invalid attempt to spread non-iterable instance");
    }

    function _iterableToArray(iter) {
      if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
    }

    function _arrayWithoutHoles(arr) {
      if (Array.isArray(arr)) {
        for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
          arr2[i] = arr[i];
        }return arr2;
      }
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    function normalizeLayout(layout) {
      return _objectSpread(_objectSpread({}, layout), {}, {
        name: layout.value,
        value: layout.url
      });
    }
    /**
     * SelectLayout
     *
     * This component shows a list of available layouts to select in expanded tree
     * and allows to filter them by searching.
     *
     * @review
     */

    var SelectLayout = function SelectLayout(_ref) {
      var checkDisplayPage = _ref.checkDisplayPage,
          config = _ref.config,
          followURLOnTitleClick = _ref.followURLOnTitleClick,
          groupId = _ref.groupId,
          itemSelectorSaveEvent = _ref.itemSelectorSaveEvent,
          multiSelection = _ref.multiSelection,
          nodes = _ref.nodes,
          privateLayout = _ref.privateLayout;
      var loadMoreItemsURL = config.loadMoreItemsURL,
          maxPageSize = config.maxPageSize,
          namespace = config.namespace;

      var _useState = (0, _react.useState)(),
          _useState2 = _slicedToArray(_useState, 2),
          filterQuery = _useState2[0],
          setFilterQuery = _useState2[1];

      var _useState3 = (0, _react.useState)([]),
          _useState4 = _slicedToArray(_useState3, 2),
          selectionData = _useState4[0],
          setSelectionData = _useState4[1];

      var handleSelectionChange = (0, _react.useCallback)(function (_, selectedNodes) {
        if (!selectedNodes.length) {
          return;
        }

        var nodes = selectedNodes.map(normalizeLayout);
        var nextData = multiSelection ? nodes : [nodes];
        setSelectionData(nextData);

        if (followURLOnTitleClick) {
          Liferay.Util.getOpener().document.location.href = nextData.url;
        } else {
          Liferay.fire(itemSelectorSaveEvent, {
            data: nextData
          });
          Liferay.Util.getOpener().Liferay.fire(itemSelectorSaveEvent, {
            data: nextData
          });
        }
      }, [followURLOnTitleClick, itemSelectorSaveEvent, multiSelection]);
      var onSearchResultSelect = (0, _react.useCallback)(function (layout) {
        var node = normalizeLayout(layout);
        var nextData = node;

        if (multiSelection) {
          if (selectionData.some(function (_ref2) {
            var id = _ref2.id;
            return id === layout.id;
          })) {
            nextData = selectionData.filter(function (_ref3) {
              var id = _ref3.id;
              return id !== layout.id;
            });
          } else {
            nextData = [].concat(_toConsumableArray(selectionData), [node]);
          }

          setSelectionData(nextData);
        }

        if (followURLOnTitleClick) {
          Liferay.Util.getOpener().document.location.href = nextData.url;
        } else {
          Liferay.fire(itemSelectorSaveEvent, {
            data: nextData
          });
          Liferay.Util.getOpener().Liferay.fire(itemSelectorSaveEvent, {
            data: nextData
          });
        }
      }, [followURLOnTitleClick, itemSelectorSaveEvent, multiSelection, selectionData]);
      var empty = nodes.length === 0;
      var onLoadMore = (0, _react.useCallback)(function (item) {
        var _Liferay$Util$objectT;

        if (!item.hasChildren) {
          return Promise.resolve({
            cursor: null,
            items: null
          });
        }

        var cursor = item.children ? Math.floor(item.children.length / maxPageSize) : 0;
        return (0, _frontendJsWeb.fetch)(loadMoreItemsURL, {
          body: Liferay.Util.objectToURLSearchParams((_Liferay$Util$objectT = {}, _defineProperty(_Liferay$Util$objectT, "groupId", groupId), _defineProperty(_Liferay$Util$objectT, "layoutUuid", item.id), _defineProperty(_Liferay$Util$objectT, "parentLayoutId", item.layoutId), _defineProperty(_Liferay$Util$objectT, "privateLayout", privateLayout), _defineProperty(_Liferay$Util$objectT, "redirect", window.location.pathname + window.location.search), _defineProperty(_Liferay$Util$objectT, "showHiddenLayouts", true), _defineProperty(_Liferay$Util$objectT, "start", cursor * maxPageSize), _Liferay$Util$objectT)),
          method: 'post'
        }).then(function (response) {
          return response.json();
        }).then(function (_ref4) {
          var hasMoreElements = _ref4.hasMoreElements,
              nextItems = _ref4.items;
          return {
            cursor: hasMoreElements ? cursor + 1 : null,
            items: nextItems
          };
        }).catch(function () {
          return (0, _frontendJsWeb.openToast)({
            message: Liferay.Language.get('an-unexpected-error-occurred'),
            title: Liferay.Language.get('error'),
            type: 'danger'
          });
        });
      }, [groupId, loadMoreItemsURL, maxPageSize, privateLayout]);
      return (/*#__PURE__*/_react.default.createElement("div", {
          className: "select-layout"
        }, /*#__PURE__*/_react.default.createElement(_managementToolbar.default, null, /*#__PURE__*/_react.default.createElement(_managementToolbar.default.Search, {
          onSubmit: function onSubmit(event) {
            event.preventDefault();
          }
        }, /*#__PURE__*/_react.default.createElement(_form.ClayInput.Group, null, /*#__PURE__*/_react.default.createElement(_form.ClayInput.GroupItem, null, /*#__PURE__*/_react.default.createElement(_form.ClayInput, {
          className: "form-control input-group-inset input-group-inset-after",
          disabled: empty,
          name: "filterKeywords",
          onInput: function onInput(event) {
            setFilterQuery(event.target.value.toLowerCase());
          },
          placeholder: Liferay.Language.get('search-for'),
          type: "text"
        }), /*#__PURE__*/_react.default.createElement(_form.ClayInput.GroupInsetItem, {
          after: true,
          tag: "span"
        }, /*#__PURE__*/_react.default.createElement(_button.ClayButtonWithIcon, {
          className: "navbar-breakpoint-d-none",
          disabled: empty,
          displayType: "unstyled",
          symbol: "times"
        }), /*#__PURE__*/_react.default.createElement(_button.ClayButtonWithIcon, {
          className: "navbar-breakpoint-d-block",
          disabled: empty,
          displayType: "unstyled",
          symbol: "search"
        })))))), /*#__PURE__*/_react.default.createElement(_layout.default.ContainerFluid, {
          className: "layouts-selector",
          id: "".concat(namespace, "selectLayoutFm")
        }, /*#__PURE__*/_react.default.createElement("fieldset", {
          className: "panel-body"
        }, empty ? /*#__PURE__*/_react.default.createElement(EmptyState, null) : filterQuery ? /*#__PURE__*/_react.default.createElement(_SearchResults.default, {
          checkDisplayPage: checkDisplayPage,
          filter: filterQuery,
          findLayoutsURL: config.findLayoutsURL,
          groupId: groupId,
          multiSelection: multiSelection,
          onSelect: onSearchResultSelect,
          selection: selectionData.map(function (_ref5) {
            var id = _ref5.id;
            return id;
          })
        }) : /*#__PURE__*/_react.default.createElement("div", {
          className: "layout-tree",
          id: "".concat(namespace, "layoutContainer")
        }, /*#__PURE__*/_react.default.createElement(_frontendJsComponentsWeb.Treeview, {
          NodeComponent: _frontendJsComponentsWeb.Treeview.Card,
          filterQuery: filterQuery,
          initialSelectedNodeIds: new Set(selectionData.map(function (layout) {
            return layout.id;
          })),
          multiSelection: multiSelection,
          nodes: nodes,
          onLoadMore: onLoadMore,
          onSelectedNodesChange: handleSelectionChange
        })))))
      );
    };

    var EmptyState = function EmptyState() {
      return (/*#__PURE__*/_react.default.createElement("div", {
          className: "sheet taglib-empty-result-message"
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: "taglib-empty-result-message-header"
        }), /*#__PURE__*/_react.default.createElement("div", {
          className: "sheet-text text-center"
        }, Liferay.Language.get('there-are-no-pages')))
      );
    };

    var _default = SelectLayout;
    exports.default = _default;
    //# sourceMappingURL=SelectLayout.es.js.map
  }
});
//# sourceMappingURL=SelectLayout.es.js.map